%global engine_etc /etc/ovirt-engine
%global engine_data %{_datadir}/ovirt-engine
%global jetty_deployments %{_datadir}/jetty/webapps

%define _jettydir %{_javadir}/jetty

%if 0%{?rhel} && 0%{?rhel} >= 7
%global with_jetty 0
%global with_jboss 1
%global jboss_deployments /var/lib/jbossas/standalone/deployments
%endif

%if 0%{?rhel} && 0%{?rhel} < 7
%global with_jetty 0
%global with_jboss 1
# oVirt distribution of JBoss
%global jboss_deployments /var/lib/jbossas/standalone/deployments
%endif

%if 0%{?fedora} && 0%{?fedora} < 20
%global with_jboss 1
%global with_jetty 1
%global jboss_deployments %{_datadir}/jboss-as/standalone/deployments
%endif

%if 0%{?fedora} && 0%{?fedora} >= 20
%global with_jboss 0
%global with_jetty 1
%endif

# The version macro to be redefined by Jenkins build when needed
%define project_version 0.8
%{!?_version: %define _version %{project_version}}

Name:		ovirt-optimizer
Version:	%{_version}
Release:	1
Summary:	Cluster balance optimization service for RHEVM
Group:		Virtualization/Management
License:	ASL 2.0
URL:		http://www.ovirt.org

Source0: ovirt-optimizer-0.8-scm-sources.zip
Source1: maven-metadata.xml.sha1
Source2: maven-metadata.xml.md5
Source3: maven-metadata.xml
Source4: ovirt-optimizer-core-0.8.pom.sha1
Source5: ovirt-optimizer-core-0.8.jar.md5
Source6: ovirt-optimizer-core-0.8.pom
Source7: ovirt-optimizer-core-0.8.jar.sha1
Source8: ovirt-optimizer-core-0.8.jar
Source9: ovirt-optimizer-core-0.8-sources.jar
Source10: ovirt-optimizer-core-0.8-sources.jar.md5
Source11: ovirt-optimizer-core-0.8.pom.md5
Source12: ovirt-optimizer-core-0.8-sources.jar.sha1
Source13: maven-metadata.xml.sha1
Source14: maven-metadata.xml.md5
Source15: maven-metadata.xml
Source16: ovirt-optimizer-jetty-0.8.war.md5
Source17: ovirt-optimizer-jetty-0.8.war.sha1
Source18: ovirt-optimizer-jetty-0.8.war
Source19: ovirt-optimizer-jetty-0.8-sources.jar.sha1
Source20: ovirt-optimizer-jetty-0.8-sources.jar.md5
Source21: ovirt-optimizer-jetty-0.8.pom
Source22: ovirt-optimizer-jetty-0.8.pom.sha1
Source23: ovirt-optimizer-jetty-0.8-sources.jar
Source24: ovirt-optimizer-jetty-0.8.pom.md5
Source25: maven-metadata.xml.sha1
Source26: maven-metadata.xml.md5
Source27: maven-metadata.xml
Source28: ovirt-optimizer-0.8.pom
Source29: ovirt-optimizer-0.8.pom.sha1
Source30: ovirt-optimizer-0.8.pom.md5
Source31: maven-metadata.xml.sha1
Source32: maven-metadata.xml.md5
Source33: maven-metadata.xml
Source34: ovirt-optimizer-jboss7-0.8.pom.md5
Source35: ovirt-optimizer-jboss7-0.8.pom
Source36: ovirt-optimizer-jboss7-0.8.war.sha1
Source37: ovirt-optimizer-jboss7-0.8.pom.sha1
Source38: ovirt-optimizer-jboss7-0.8.war
Source39: ovirt-optimizer-jboss7-0.8.war.md5

BuildArch:	noarch

BuildRequires:	unzip
BuildRequires:  symlinks

Requires:	java >= 1:1.7.0
Requires:	jpackage-utils

%if 0%{?fedora} || 0%{?rhel} >= 7
Requires:       quartz
Requires:       protobuf-java >= 2.5
Requires:       xpp3
%endif

Requires:       slf4j
Requires:       rhevm-sdk-java >= 3.5.2.0

%description
%{name} service collects data from the oVirt engine and proposes
Vm to host assignments to utilize cluster resources better.

%package ui
Summary:        UI for displaying results in oVirt webadmin
Requires:	    rhevm-webadmin-portal >= 3.5

%description ui
This subpackage adds an UI plugin to the oVirt webadmin portal.
This plugin then adds a Tab to the cluster display and presents
the assingment recommendations to the sysadmin there.

%if 0%{?with_jboss}
%package jboss7
Summary:       Integration of the optimization service to Jboss 7.
Requires:      %{name} = %{version}
Requires:      %{name}-dependencies = %{version}

%if 0%{?fedora}
Requires:	   jboss-as >= 7.1.1-9.3
Requires:          antlr3
%endif

%if 0%{?rhel}
Requires:	   jbossas-standalone >= 7.1.1-1
%endif

%if 0%{?rhel} && 0%{?rhel} < 7
# Old package names for el6
Requires:      jakarta-commons-lang
Requires:      jakarta-commons-io
%endif

%description jboss7
This subpackage deploys the optimizer service to the standard Jboss 7
application server.
%endif

%if 0%{?with_jetty}
%package jetty
Summary:       Integration of the optimization service to Jetty 9.
Requires:      %{name} = %{version}
Requires:      %{name}-dependencies = %{version}
Requires:      jetty >= 9
Requires:      cdi-api
Requires:      resteasy
Requires:      jackson
Requires:      jboss-annotations-1.1-api
Requires:      jboss-transaction-1.1-api
Requires:      tomcat-jsp-2.2-api
Requires:      antlr3
Requires:      apache-commons-math >= 3
Requires:      ecj

%description jetty
This subpackage deploys the optimizer service to Jetty application
server.
%endif

%package dependencies
Summary:       Libraries not currently provided by the system, but necessary for the project.

%description dependencies
This subpackage bundles libraries that are not provided in the form of RPMs, but are necessary
for the project to work. The goal is to drop this subpackage once the dependencies are available.


%prep

%build
# recreate maven target structure from MEAD artifacts
  namewithver=$(basename ovirt-optimizer-0.8-scm-sources)
  name=${namewithver%%-*}
    unzip -o %{SOURCE0}
    mv ovirt-optimizer/dist ovirt-optimizer/README ovirt-optimizer/COPYING .
  namewithver=$(basename maven-metadata.xml.)
  name=${namewithver%%-*}
  namewithver=$(basename maven-metadata.xml)
  name=${namewithver%%-*}
  namewithver=$(basename maven-metadata)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-core-0.8.pom.)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-core-0.8.jar)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-core-0.8)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-core-0.8.jar.)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-core-0.8)
  name=${namewithver%%-*}
    mkdir -p $name/target/$name
    cp %{SOURCE8} $name/target/$name.jar
  namewithver=$(basename ovirt-optimizer-core-0.8-sources)
  name=${namewithver%%-*}
    mkdir -p $name/target/$name
    cp %{SOURCE9} $name/target/$name.jar
  namewithver=$(basename ovirt-optimizer-core-0.8-sources.jar)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-core-0.8.pom)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-core-0.8-sources.jar.)
  name=${namewithver%%-*}
  namewithver=$(basename maven-metadata.xml.)
  name=${namewithver%%-*}
  namewithver=$(basename maven-metadata.xml)
  name=${namewithver%%-*}
  namewithver=$(basename maven-metadata)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jetty-0.8.war)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jetty-0.8.war.)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jetty-0.8)
  name=${namewithver%%-*}
    mkdir -p $name/target/$name
    cp %{SOURCE18} $name/target
    pushd $name/target/$name
    unzip -o ../*.war
    popd
  namewithver=$(basename ovirt-optimizer-jetty-0.8-sources.jar.)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jetty-0.8-sources.jar)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jetty-0.8)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jetty-0.8.pom.)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jetty-0.8-sources)
  name=${namewithver%%-*}
    mkdir -p $name/target/$name
    cp %{SOURCE23} $name/target/$name.jar
  namewithver=$(basename ovirt-optimizer-jetty-0.8.pom)
  name=${namewithver%%-*}
  namewithver=$(basename maven-metadata.xml.)
  name=${namewithver%%-*}
  namewithver=$(basename maven-metadata.xml)
  name=${namewithver%%-*}
  namewithver=$(basename maven-metadata)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-0.8)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-0.8.pom.)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-0.8.pom)
  name=${namewithver%%-*}
  namewithver=$(basename maven-metadata.xml.)
  name=${namewithver%%-*}
  namewithver=$(basename maven-metadata.xml)
  name=${namewithver%%-*}
  namewithver=$(basename maven-metadata)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jboss7-0.8.pom)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jboss7-0.8)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jboss7-0.8.war.)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jboss7-0.8.pom.)
  name=${namewithver%%-*}
  namewithver=$(basename ovirt-optimizer-jboss7-0.8)
  name=${namewithver%%-*}
    mkdir -p $name/target/$name
    cp %{SOURCE38} $name/target
    pushd $name/target/$name
    unzip -o ../*.war
    popd
  namewithver=$(basename ovirt-optimizer-jboss7-0.8.war)
  name=${namewithver%%-*}

cat >COPYING.csv <<EOF
"Required by","Name","Version","License","Summary","URL","Repository"
"drools-compiler(ASL 2.0)", "antlr-runtime", "3.5", "BSD", "Framework for constructing recognizers, interpreters, compilers.", "http://www.antlr3.org/", "ovirt-optimizer-dependencies"
"optaplanner-core(ASL 2.0)", "commons-math3", "3.2", "ASL 2.0", "Math and statistics library.", "http://commons.apache.org/proper/commons-math/", "ovirt-optimizer-dependencies"
"optaplanner-core(ASL 2.0)", "drools-compiler", "6.2.0", "ASL 2.0", "Drools language compiler", "http://www.drools.org/", "ovirt-optimizer-dependencies"
"optaplanner-core(ASL 2.0)", "drools-core", "6.2.0", "ASL 2.0", "Drools base", "http://www.drools.org/", "ovirt-optimizer-dependencies"
"optaplanner-core(ASL 2.0)", "guava", "13.0.1", "ASL 2.0", "Google core library", "https://github.com/google/guava", "ovirt-optimizer-dependencies"
"optaplanner-core(ASL 2.0)", "kie-api", "6.2.0", "ASL 2.0", "KIE Drools API", "http://www.drools.org/", "ovirt-optimizer-dependencies"
"optaplanner-core(ASL 2.0)", "kie-internal", "6.2.0", "ASL 2.0", "KIE Drools internal", "http://www.drools.org/", "ovirt-optimizer-dependencies"
"drools-core(ASL 2.0)", "mvel2", "2.2.1", "ASL 2.0", "Expression language for java applications", "https://github.com/mvel/mvel", "ovirt-optimizer-dependencies"
"drools-compiler(ASL 2.0)", "protobuf-java", "2.5.0", "BSD", "Protocol Buffers are a way of encoding structured data in an efficient yet extensible format.", "https://github.com/google/protobuf/", "ovirt-optimizer-dependencies"
"ovirt-optimizer(ASL 2.0)", "optaplanner-core", "6.2.0", "ASL 2.0", "Optaplanner optimization library (part of Drools)", "http://www.optaplanner.org/", "ovirt-optimizer-dependencies"
"ovirt-optimizer(ASL 2.0)", "quartz", "2.2.0", "ASL 2.0", "Timer and scheduling library", "http://quartz-scheduler.org/", "ovirt-optimizer-dependencies"
"xstream(BSD)", "xmlpull", "1.1.3.1", "Public Domain", "xmlpull API", "http://www.xmlpull.org/", "ovirt-optimizer-dependencies"
"optaplanner-core(ASL 2.0)", "xpp3_min", "1.1.4c", "ASL 1.1", "Fast implementation of xmlpull API", "http://www.extreme.indiana.edu/xgws/xsoap/xpp/mxp1/index.html", "ovirt-optimizer-dependencies"
"optaplanner-core(ASL 2.0)", "xstream", "1.4.7", "BSD", "XML serialization library", "http://xstream.codehaus.org/", "ovirt-optimizer-dependencies"
EOF

%install

# Copy core jars to the proper place
install -dm 755 %{buildroot}%{_javadir}/%{name}
install -dm 755 %{buildroot}%{_javadir}/%{name}/bundled
mv ovirt-optimizer-core/target/ovirt-optimizer-core.jar %{buildroot}%{_javadir}/%{name}


pushd ovirt-optimizer-jboss7

# Remove the bundled jars by moving them elsewhere and then
# copying only the needed files back. The rest is provided
# by this package's dependencies.
mkdir target/lib
mv target/ovirt-optimizer-jboss7/WEB-INF/lib/* target/lib

JBOSS_SYMLINK="%{_javadir}/%{name}/%{name}-core.jar
%{_javadir}/commons-beanutils.jar
%{_javadir}/commons-codec.jar
%{_javadir}/commons-logging.jar
%{_javadir}/commons-io.jar
%{_javadir}/commons-lang.jar
%if 0%{?fedora} || 0%{?rhel} >= 7
%{_javadir}/antlr3.jar
%{_javadir}/antlr3-runtime.jar
%{_javadir}/commons-math3.jar
%{_javadir}/protobuf.jar
%{_javadir}/quartz.jar
%{_javadir}/guava.jar
%{_javadir}/xpp3.jar
%endif
%{_javadir}/httpcore.jar
%{_javadir}/httpclient.jar
%{_javadir}/rhevm-sdk-java/rhevm-sdk-java.jar"

JBOSS_BUNDLE="target/lib/drools-*
target/lib/kie-*
target/lib/optaplanner-*
%if 0%{?rhel} && 0%{?rhel} < 7
target/lib/antlr-*
target/lib/guava-*
target/lib/quartz-*
target/lib/protobuf-java-*
target/lib/commons-math3-*
target/lib/xpp3*
%endif
target/lib/mvel2-*
target/lib/xmlpull-*
target/lib/xstream-*"



%if 0%{?with_jboss}

# Install the exploded Jboss war to javadir
cp -ar target/ovirt-optimizer-jboss7 %{buildroot}%{_javadir}/%{name}/jboss7.war

# Symlink libs to %{buildroot}%{_javadir}/%{name}/jboss7/WEB-INF/lib
echo "$JBOSS_SYMLINK" | xargs -d \\n -I@ sh -c "ln -s -t %{buildroot}%{_javadir}/%{name}/jboss7.war/WEB-INF/lib @"

# Copy bundled libs to %{buildroot}%{_javadir}/%{name}/bundled
echo "$JBOSS_BUNDLE" | xargs -d \\n -I@ sh -c "cp -t %{buildroot}%{_javadir}/%{name}/bundled @"

# Symlink the bundled libs to %{buildroot}%{_javadir}/%{name}/jboss7/WEB-INF/lib
cp -Rs %{buildroot}%{_javadir}/%{name}/bundled/* %{buildroot}%{_javadir}/%{name}/jboss7.war/WEB-INF/lib
symlinks -rc %{buildroot}%{_javadir}/%{name}/jboss7.war/WEB-INF/lib

# Symlink it to Jboss war directory and touch the deploy marker
install -dm 755 %{buildroot}%{jboss_deployments}
ln -sf %{_javadir}/%{name}/jboss7.war %{buildroot}%{jboss_deployments}/%{name}.war
touch %{buildroot}%{jboss_deployments}/%{name}.war.dodeploy

%endif

popd


pushd ovirt-optimizer-jetty

# Remove the bundled jars by moving them elsewhere and then
# copying only the needed files back. The rest is provided
# by this package's dependencies.
mkdir target/lib
mv target/ovirt-optimizer-jetty/WEB-INF/lib/* target/lib

JETTY_SYMLINK="%{_javadir}/resteasy/resteasy-cdi.jar
%{_javadir}/resteasy/resteasy-jackson-provider.jar
%{_javadir}/resteasy/resteasy-jaxrs.jar
%{_javadir}/resteasy/jaxrs-api.jar
%{_javadir}/jackson/jackson-core-asl.jar
%{_javadir}/jackson/jackson-jaxrs.jar
%{_javadir}/jackson/jackson-mapper-asl.jar
%{_javadir}/jackson/jackson-xc.jar
%if 0%{?rhel} || 0%{?fedora} < 20
%{_javadir}/cdi-api.jar
%endif
%if 0%{?fedora} && 0%{?fedora}>=20
%{_javadir}/cdi-api/cdi-api.jar
%endif
%{_javadir}/c3p0.jar
%{_javadir}/javassist.jar
%{_javadir}/scannotation.jar
%{_javadir}/slf4j/slf4j-api.jar
%{_javadir}/slf4j/slf4j-log4j12.jar
%{_javadir}/log4j.jar
%{_javadir}/elspec.jar
%{_javadir}/ecj.jar
%{_jettydir}/jetty-jmx.jar
%{_jettydir}/jetty-server.jar
%{_jettydir}/jetty-servlet.jar
%{_jettydir}/jetty-util.jar
%{_javadir}/jboss-annotations-1.1-api.jar
%{_javadir}/jboss-interceptors-1.1-api.jar
%{_javadir}/jsp.jar
%{_javadir}/jcip-annotations.jar"

JETTY_BUNDLE="target/lib/weld-*
target/lib/activation-1.1*
target/lib/javax.inject-1.jar
target/lib/jsr250-*"

%if 0%{?with_jetty}

# Install the exploded Jetty war to javadir
install -dm 755 %{buildroot}%{_javadir}/%{name}/jetty
cp -ar target/ovirt-optimizer-jetty %{buildroot}%{_javadir}/%{name}/jetty/%{name}

# Symlink libs to %{buildroot}%{_javadir}/%{name}/jetty/%{name}/WEB-INF/lib
echo "$JBOSS_SYMLINK" | xargs -d \\n -I@ sh -c "ln -s -t %{buildroot}%{_javadir}/%{name}/jetty/%{name}/WEB-INF/lib @"
echo "$JETTY_SYMLINK" | xargs -d \\n -I@ sh -c "ln -s -t %{buildroot}%{_javadir}/%{name}/jetty/%{name}/WEB-INF/lib @"

# Copy bundled libs to %{buildroot}%{_javadir}/%{name}/bundled
echo "$JETTY_BUNDLE" | xargs -d \\n -I@ sh -c "cp -t %{buildroot}%{_javadir}/%{name}/bundled @"

# Symlink the bundled libs to %{buildroot}%{_javadir}/%{name}/jetty/%{name}/WEB-INF/lib
cp -Rs %{buildroot}%{_javadir}/%{name}/bundled/* %{buildroot}%{_javadir}/%{name}/jetty/%{name}/WEB-INF/lib
symlinks -rc %{buildroot}%{_javadir}/%{name}/jetty/%{name}/WEB-INF/lib

# Symlink it to Jetty war directory and touch the deploy marker
install -dm 755 %{buildroot}%{jetty_deployments}
ln -sf %{_javadir}/%{name}/jetty/%{name} %{buildroot}%{jetty_deployments}/%{name}

%endif

popd


# Copy the setup script to documentation
install -dm 755 %{buildroot}%{_docdir}/%{name}-%{version}


# Install the UI plugin to the oVirt webadmin
install -dm 755 %{buildroot}%{engine_data}/ui-plugins
install -dm 755 %{buildroot}%{engine_etc}/ui-plugins
install -dm 755 %{buildroot}%{engine_data}/ui-plugins/ovirt-optimizer-resources
install dist/ovirt-optimizer-uiplugin/*.json %{buildroot}%{engine_data}/ui-plugins/
install dist/ovirt-optimizer-uiplugin/ovirt-optimizer-resources/* %{buildroot}%{engine_data}/ui-plugins/ovirt-optimizer-resources
install dist/etc/*.json %{buildroot}%{engine_etc}/ui-plugins/

# Install config file
install -dm 755 %{buildroot}/etc/%{name}
install dist/etc/*.properties %{buildroot}/etc/%{name}

%files
%defattr(644, root, root, 755)
%doc README COPYING
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%attr(640, root, jboss) %config /etc/%{name}/*

%if 0%{?with_jetty}
%files jetty
%defattr(644, root, root, 755)
%dir %{_javadir}/%{name}/jetty/%{name}
%{_javadir}/%{name}/jetty/%{name}/*
%{jetty_deployments}/*
%endif

%if 0%{?with_jboss}
%files jboss7
%defattr(644, root, root, 755)
%dir %{_javadir}/%{name}/jboss7.war
%{_javadir}/%{name}/jboss7.war/*
%{jboss_deployments}/*
%endif

%files ui
%defattr(644, root, root, 755)
%dir %{engine_data}/ui-plugins/ovirt-optimizer-resources
%config %{engine_etc}/ui-plugins/ovirt-optimizer-config.json
%{engine_data}/ui-plugins/ovirt-optimizer.json
%{engine_data}/ui-plugins/ovirt-optimizer-resources/*

%files dependencies
%defattr(644, root, root, 755)
%doc COPYING.csv
%dir %{_javadir}/%{name}/bundled
%{_javadir}/%{name}/bundled/*

%changelog
* Thu May 07 2015 Martin Sivak <msivak@redhat.com> 0.8-1
- Improve UI usability
- Do not forget part of the solution on cluster update
- Add hosted engine policy rules
- Fix PinToHost rules
- Do not start VMs without being asked to
- Add support for custom rules
- Use cluster policy specific configuration before the defaults
- Fix CSRF and login issues when accessing engine's REST
- Fix the protocol for downloading jQuery

* Thu Nov 20 2014 Martin Sivak <msivak@redhat.com> 0.4-5
- Improve UI logic of Optimize start and cancel buttons
  Resolves: rhbz#1140723

* Mon Nov 10 2014 Martin Sivak <msivak@redhat.com> 0.4-4
- Fix uuid matching rules for even distribution policies
  Resolves: rhbz#1156141

- Fix the way we collect cluster policy parameters
  Related: rhbz#1156141

- Fix the UI styling so it looks more like RHEV
  Resolves: rhbz#1162955

* Tue Oct 07 2014 Martin Sivak <msivak@redhat.com> 0.4-3
- Add missing xmlpull library
  Related rhbz#877209

* Tue Oct 07 2014 Martin Sivak <msivak@redhat.com> 0.4-2
- Separate bundled libraries to dependencies subpackage
  Related rhbz#877209

* Mon Sep 22 2014 Martin Sivak <msivak@redhat.com> 0.4-1
- Fixed REST endpoint urls in UI plugin
  Resolves rhbz#1140721

* Wed Sep 10 2014 Martin Sivak <msivak@redhat.com> 0.3-4
- Fix config file permissions
  Resolves: rhbz#1140127

* Tue Sep 04 2014 Martin Sivak <msivak@redhat.com> 0.3-3
- Fix file permissions
  Related: rhbz#877209

* Mon Sep 03 2014 Martin Sivak <msivak@redhat.com> 0.3-2
- Fix the path to RHEVM java sdk and http commons libs
  Related: rhbz#877209

* Mon Sep 03 2014 Martin Sivak <msivak@redhat.com> 0.3-1
Initial release for RHEV 3.5

